// Chapter 4 of C++ How to Program
// Programming Challenge 12

#include <iostream> 

using std::cout; 
using std::endl; 

#include <iomanip> 

using std::setw; 

#include <cstdlib>
#include <ctime>

const int MAXRANGE = 1000;
int recursiveMinimum( const int [], int, int );

int main()
{
   const int SIZE = 10;
   int array[ SIZE ];
   int smallest;

   srand( time( 0 ) );

   for ( int loop = 0; loop < SIZE; ++loop )
      array[ loop ] = 1 + rand() % MAXRANGE;

   cout << '\a';
   cout << "Array members are:\n";
   
   for ( int k = 0; k < SIZE; ++k )
      cout << setw( 5 ) << array[ k ];

   cout << '\n';
   
   smallest = recursiveMinimum( array, 0, SIZE - 1 );
   
   cout << "\nSmallest element is: " << smallest << endl;

   return 0;

} // end main

// function recursiveMinimum definition
int recursiveMinimum( const int array[], int low, int high )
{
   if ( low == high )
      return array[ low ];

   int minimum = recursiveMinimum( array, low + 1, high);

   return array[ low ] < minimum ? array[ low ] : minimum;

} // end function recursiveMinimum

 /**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
