// Chapter 5 of C++ How to Program
// Programming Challenge 14 (Solution)
// NOTE: THIS PROGRAM ONLY HANDLES VALUES UP TO $999.99
// The program is easily modified to process larger values

#include <iostream> 

using std::cout; 
using std::endl; 
using std::cin; 

int main()
{
   const char *digits[ 10 ] = { "", "ONE", "TWO", "THREE",
                                "FOUR", "FIVE", "SIX",
                                "SEVEN", "EIGHT", "NINE" };
   
   const char *teens[ 10 ] = { "", "ELEVEN", "TWELVE",
                               "THIRTEEN", "FOURTEEN", 
                               "FIFTEEN", "SIXTEEN", 
                               "SEVENTEEN", "EIGHTEEN", 
                               "NINETEEN" };
   
   const char *hundred = "HUNDRED";
   
   const char *tens[ 10 ] = { "", "TEN", "TWENTY", "THIRTY", 
                              "FOURTY", "FIFTY", "SIXTY"
                              "SEVENTY", "EIGHTY", "NINETY" };
    

   int dollars;
   int cents;
   int digit1;
   int digit2;
   int digit3;

   cout << "Enter the check amount (0.00 to 999.99): ";
   cin >> dollars;
   cin.ignore();
   cin >> cents;
   cout << "The check amount in words is:\n";

   if ( dollars < 10 )
       cout << digits[ dollars ] << ' ';

   else if ( dollars < 20 ) 
      cout << teens[ dollars - 10 ] << ' ';
   
   else {
      digit1 = dollars / 100;
      dollars %= 100;
      digit2 = dollars / 10;
      digit3 = dollars % 10;

      if ( digit1 > 0 )
         cout << digits[ digit1 ] << ' ' << hundred << ' ';
      if ( digit2 > 0 )
         cout << tens[ digit2 ] << ' ';
      if ( digit3 > 0 )
         cout << digits[ digit3 ] << ' ';
   
   } // end else

   cout << "Dollars and " << cents << "/100" << endl;

   return 0;

} // end main


/**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/