// time.cpp
// member function definitions for time.cpp
#include <iostream> 

using std::cout; 

#include "time.h"

// constructor
Time::Time( int hr, int min, int sec ) 
{ 
   setTime( hr, min, sec ); 

} // end class Time constructor

// set Time object 
void Time::setTime( int h, int m, int s )
{
   setHour( h );
   setMinute( m );
   setSecond( s );

} // end function setTime

// set hour
void Time::setHour( int h ) 
{ 
   hour = ( h >= 0 && h < 24 ) ? h : 0; 

} // end function setHour

// set minute
void Time::setMinute( int m ) 
{	
	minute = ( m >= 0 && m < 60 ) ? m : 0;

} // end function setMinute

// set second
void Time::setSecond( int s ) 
{ 	
	second = ( s >= 0 && s < 60 ) ? s : 0; 

} // end function setSecond

// return hour
int Time::getHour() 
{ 
   return hour; 

} // end function getHour 

// return minute
int Time::getMinute() 
{ 
   return minute; 

} // end function getMinute

// return second
int Time::getSecond() 
{ 
   return second; 

} // end function getSecond

// function printStandard definition
void Time::printStandard()
{
   cout << ( ( hour % 12 == 0 ) ? 12 : hour % 12 ) << ':'
         << ( minute < 10 ? "0" : "" ) << minute << ':'
         << ( second < 10 ? "0" : "" ) << second
         << ( hour < 12 ? " AM" : " PM" );

} // end function printStandard

// function tick definition
void Time::tick()
{
   setSecond( getSecond() + 1 );

   if ( getSecond() == 0 ) {
      setMinute( getMinute() + 1 );

      if ( getMinute() == 0 )
         setHour( getHour() + 1 );
   
   } // end if

} // end function tick

 /**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
