// rectangle.cpp
// member function definitions for rectangle.cpp

#include "rectangle.h"

// constructor
Rectangle::Rectangle( double w, double l )
{
   setWidth( w );
   setLength( l );

} // end class Rectangle constructor

// function perimeter definition
double Rectangle::perimeter() 
{ 
	return 2 * ( width + length ); 

} // end function perimeter

// function area definition
double Rectangle::area() 
{ 
	return width * length; 

} // end function area

// set width
void Rectangle::setWidth( double w ) 
{ 
	width = w > 0 && w < 20.0 ? w : 1.0; 

} // end function setWidth

// set length
void Rectangle::setLength( double l ) 
{ 
	length = l > 0 && l < 20.0 ? l : 1.0; 

} // end function setLength

// return width
double Rectangle::getWidth() 
{ 
   return width; 

} // end function getWidth

// return length
double Rectangle::getLength() 
{ 
   return length; 

} // end function getLength

 /**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/