// Chapter 7 of C++ How to Program
// Programming Challenge 11 (Solution)

#ifndef DATE_H
#define DATE_H

#include <ctime>

#include <cstring> 

// class Date definition
class Date {

public:
   Date();
   Date( int, int );
   Date( int, int, int );
   Date( char *, int, int );

   void setMonth( int );
   void setDay( int );
   void setYear( int );

   void printDateSlash() const;
   void printDateMonth() const;
   void printDateDay() const;

   const char *monthName() const;
   bool leapYear() const;
   int daysOfMonth() const;
   void convert1( int );
   int convert2() const;
   void convert3( const char * const );
   const char *monthList( int ) const;
   int days( int ) const;

private:
   int day;     
   int month;
   int year;

}; // end class Date

#endif // DATE_H


/**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/