// Chapter 7 of C++ How to Program
// Programming Challenge 12 (Solution)

#include <iostream> 

using std::cout;
using std::endl;

#include <iomanip> 

using std::setw; 

#include "savings.h"

int main()
{
   SavingsAccount saver1( 2000.0 );
   SavingsAccount saver2( 3000.0 );

   SavingsAccount::modifyInterestRate( .03 );

   cout << "\nOutput monthly balances for one year at .03" 
        << "\nBalances: Saver 1 ";
   saver1.printBalance();

   cout << "\tSaver 2 ";
   saver2.printBalance();

   for ( int month = 1; month <= 12; ++month ) {
      saver1.calculateMonthlyInterest();
      saver2.calculateMonthlyInterest();

      cout << "\nMonth" << setw( 3 ) << month << ": Saver 1 ";
      saver1.printBalance();

      cout << "\tSaver 2 ";
      saver2.printBalance();

   } // end for

   SavingsAccount::modifyInterestRate( .04 );

   saver1.calculateMonthlyInterest();
   saver2.calculateMonthlyInterest();

   cout << "\nAfter setting interest rate to .04" 
        << "\nBalances: Saver 1 ";
   saver1.printBalance();

   cout << "\tSaver 2 ";
   saver2.printBalance();
   cout << endl;

   return 0;

} // end main


 /**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
