// cube.cpp
// member function definitions for class Cube

#include <iostream> 

using std::cout; 
using std::fixed;

#include <iomanip> 

using std::setprecision; 

#include "cube.h"

// default constructor
Cube::Cube( double xValue, double yValue, double zValue, double sideValue ) 
   : Square( xValue, yValue, zValue, sideValue ) 
{ 
   // empty body

} // end class Cube constructor

// function area definition
double Cube::area() const 
{ 
   return 6 * Square::area(); 

} // end function area definition

// function volume definition
double Cube::volume() const 
{ 
   return Square::area() * getSide(); 

} // end function volume

void Cube::print() const
{
   cout << fixed
        << "The lower left coordinate of the cube is: ["
        << setprecision( 2 ) << getX() << ", " << setprecision( 2 )
        << getY() << ", " << setprecision( 2 ) << getZ() 
        << "]\nThe cube side is: " << setprecision( 2 ) << side 
        << "\nThe surface area of the cube is: " << setprecision( 2 )
        << area() << "\nThe volume of the cube is: "
        << setprecision( 2 ) << volume();

} // end function print

/**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/