// square.cpp
// member functions for class Square
#include <iostream> 

using std::cout; 
using std::fixed;

#include <iomanip> 
 
using std::setprecision; 

#include "square.h"

// default constructor
Square::Square( double xValue, double yValue, double zValue, double sideValue ) 
   : Point( xValue, yValue, zValue )
{ 
   setSide( sideValue ); 

} // end class Square constructor

// function setSide definition
void Square::setSide( double sideValue ) 
{ 
   side = sideValue > 0 && sideValue <= 20.0 ? sideValue : 1.0; 

} // end function setSide

// return side
double Square::getSide() const 
{ 
   return side; 

} // end function getSide

// function area definition
double Square::area() const 
{ 
   return side * side; 

} // end function area

// function print definition
void Square::print() const
{
   cout << fixed
        << "The lower left coordinate of the square is: ["
        << setprecision( 2 ) << getX() << ", " << setprecision( 2 )
        << getY() << ", " << setprecision( 2 ) << getZ() << ']'
        << "\nThe square side is: " << setprecision( 2 ) << side
        << "\nThe area of the square is: " << setprecision( 2 )
        << area() << '\n';
       
} // end function print

/**************************************************************************
 * (C) Copyright 1992-2003 by Deitel & Associates, Inc. and Prentice      *
 * Hall. All Rights Reserved.                                             *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/